<?php
	// path change
	$path = getcwd();
	chdir('invoice');		// make sure we are going from the invoice pat
?>
<table width="97%" border="0" cellpadding="0" cellspacing="0">
<form method="post" action="">
  <tr valign="top"> 
    <td width="25%" colspan="2">
		<?php include '../dataaccessheader.php'; ?>
	</td>
  </tr>
  <?php
  	include_once "./classes/invoice.php";
  	
  	// this section has not output and is to prepare the session data for the JS call to follow the page load
  	if (isset($_POST['display']) | isset($_GET['id'])) {
		// prepare the invoice object - that is unserialize the object and add in the ticket list
		// the reserialize it and save it to the session, so we can be ready to access it in the JS popup
		
		// clicking btnDisplay causes the update event to fire
		// but update is only done with the detection of post->id which is setup onces the invoice object is saved
		
		// we can also do several things
		if (isset($_GET['id']) && !isset($_POST['id'])) {  // post overrides get
			//echo "using get";	
			$invoice = new Invoice(intval($_GET['id']));
		}
		else if (isset($_POST['id']) && $_POST['id'] > 0) {
			//echo "using post";
			$invoice = new Invoice(intval($_POST['id']));
		}
		else if (isset($_SESSION['invoiceData'])) {
			//echo "unserializing";
			$invoice = unserialize($_SESSION['invoiceData']);
		}
		
		if (!isset($_GET['id'])) {
			if (isset($_POST['tickets']) && count($_POST['tickets'])) $invoice->tickets = $_POST['tickets'];
			else $error_msg = "You Must Select at Least One Ticket";
		}
		
		// tickets is already taken care of if we are bringing an object in from the database
		include_once "./files/process.php";
		
		exit;
	}
  
  	if (isset($_POST['submit']) && !isset($_POST['id']) && !isset($_GET['id'])) {	// this is to build a new object - look for id
  		$invoice = new Invoice();
  		
  		if ($_POST['radToSelect'] == STORED_USER)
  			$to_error = $invoice->setStoredTo( isset($_POST['selTo']) ? $_POST['selTo'] : 0 );
  		else 
  			$to_error = $invoice->setCustomTo( $_POST['txtTo'] );
  			
  		$customTitle = false;
  		$invoice->setGroup( $_POST['radGroup'] );
		if (isset($_POST['chkCustomTitle'])) {
  			$title = $_POST['txtTitle'];
  			$customTitle = true;
		}
  		else {
  			$title = "";
  			
  			// code to build the standard title
  			switch ($_POST['radGroup'])
  			{
  				case 'user':
  					$title .= "User Invoice ";
  					break;
  				case 'priority':
  					$title .= "Priority Invoice ";
  					break;
  				case 'tickID':
  					$title .= "Ticket Invoice ";
  					break;
  			}
  			
  			// further processing of title is done below after date is set
  		}
  		
  		switch ($_POST['radGroup'])
  		{
  			case 'user':
  			case 'priority':
  				$date_error = $invoice->setDateStart( $_POST[$_POST['radGroup']]['DateStart']);
  				if (!strlen($date_error))
  					$date_error = $invoice->setDateEnd( $_POST[$_POST['radGroup']]['DateEnd']);
  				if (!strlen($date_error))
  					$date_error = $invoice->validateDates();
  					
  				@$for_error = $invoice->setForValue( isset($_POST[$_POST['radGroup']]['for']) ? $_POST[$_POST['radGroup']]['for'] : array() );
  				$invoice->setSortColumn( $_POST[$_POST['radGroup']]['column'] );
  				$invoice->setSortDirection( $_POST[$_POST['radGroup']]['sort'] );
  				break;
  			case 'tickID':
  				$ticket_error = $invoice->setTicketArray( explode(',', str_replace(" ", "", $_POST['txtTicks'])));  				
  				break;
  			default: break;
  		}
  		
  		// finish title building
  		if (!$customTitle && $_POST['radGroup'] != 'tickID')
  			$title .= "for " . date("m/d/Y", $invoice->dateStart) . " and " . date("m/d/Y", $invoice->dateEnd);
  		$title_error = $invoice->setTitle( $title );
  		
  		$column_error = $invoice->setIncludeColumns( isset($_POST['columns']) ? $_POST['columns'] : array() );
  		$invoice->setCalcFinalTotalOption( isset($_POST['chkCalcTotal']) );
  		$invoice->setOneTickPerPage( isset($_POST['chkOneTick']) );
  		$invoice->setSave( isset($_POST['save']) );
		
		if (!$invoice->error) {
			// include the file to show the list
			include_once "./files/process.php";
			exit;
		}
	}
	
	// since we are going to ask the user to create a new invoice we unset the invoiceData in the sessioin if it
	// exists
	if (isset($_SESSION['invoiceData'])) unset($_SESSION['invoiceData']);
  ?>
  <tr>
  	<td colspan="2" valign="top">
  		<table cellpadding="0" cellspacing="0" border="0">
  			<tr>
  				<th valign="top" class="formtext">To:&nbsp;</td>
  				<td valign="top"></td>
  				<td valign="top">
  					<input type="radio" name="radToSelect" value="1"<?php if (!isset($_POST['radToSelect']) || $_POST['radToSelect'] == 1) echo ' checked="checked"'; ?> id="toSelect" onchange="selectToLabel(1);" />&nbsp;Select from Database<br/>
  					<select name="selTo[]" id="selTo" size="5" multiple="false">
  					<?php
  						$q = "select ID, FirstName, LastName, User from " . DB_PREFIX . "accounts order by LastName";
  						$s = mysql_query($q) or die(mysql_error());
  						while ($r = mysql_fetch_assoc($s))
  						{
  							$extra = isset($_POST['selTo']) && in_array($r['ID'], $_POST['selTo']) ? ' selected="selected"' : '';
  					?>
  						<option value="<?php echo $r['ID']; ?>"<?php echo $extra; ?>><?php echo $r['LastName']; ?>, <?php echo $r['FirstName']; ?> (<?php echo $r['User']; ?>)</option>
  					<?php
  						}
  					?>
  					</select>
  				</td>
  				<td width="10"></td>
  				<td valign="top">&nbsp;</td>
  				<td valign="top">
  					<input type="radio" name="radToSelect" value="0"<?php if (isset($_POST['radToSelect']) && $_POST['radToSelect'] == 0) echo ' checked="checked"'; ?> id="toTextarea" onchange="selectToLabel(0);" />&nbsp;Use Custom<br/>
  					<textarea id="txtTo" name="txtTo" rows="5" cols="30"><?php echo isset($_POST['txtTo']) ? $_POST['txtTo'] : ''; ?></textarea>
  				</td>
  			</tr>
  			<tr><td colspan="6" class="error">
  				<?php echo isset($to_error) ? $to_error : ''; ?>
  			</td></tr>
  		</table>
  	</td>
  </tr>
  <tr>
  	<td colspan="2">
  		<table cellpadding="0" cellspacing="0" border="0" align="left">
  			<tr>
  				<th align="left">Title of Invoice:&nbsp;</th>
  				<td width="10"></td>
  				<td>
  					<input type="text" name="txtTitle" id="txtTitle" size="20" maxlength="100" value="<?php echo isset($_POST['txtTitle']) ? $_POST['txtTitle'] : ''; ?>">&nbsp;
  					<input type="checkbox" name="chkCustomTitle" id="chkCustomTitle" value="0" onchange="titleboxcheck();"<?php echo isset($_POST['chkCustomTitle']) ? ' checked="checked"' : ''; ?> />&nbsp;Use Custom Title
  				</td>
  			</tr>
  			<tr><td colspan="3" class="error">
  				<?php echo isset($title_error) ? $title_error : ''; ?>
  			</td></tr>
  		</table>
  	</td>
  </tr>
  <tr><td colspan="2"><hr/></td></tr>
  <tr><th colspan="2" align="left" valign="top">
  	Grouping:<br/>
  </th></tr>
  <tr><td colspan="2" valign="top" style="padding-left: 5px;">
 	<input type="radio" name="radGroup" id="radGroup" value="user"<?php if ($_POST['radGroup'] == 'user') echo ' checked="checked"'; ?> onchange="LoadOptions('user');" />&nbsp;User<br/>
  	<div style="padding-left: 10px;">
	  	<table cellpadding="0" cellspacing="0" border="0" width="75%">
	  		<tr>
	  			<th align="left" valign="top">For User(s):&nbsp;</th>
	  			<td colspan="4" valign="top">
	  			<select name="user[for][]" id="theUser" size="5" multiple="true">
  					<?php
  						$q = "select ID, FirstName, LastName, User from " . DB_PREFIX . "accounts where securityLevel > 0 order by LastName";
  						$s = mysql_query($q) or die(mysql_error());
  						while ($r = mysql_fetch_assoc($s))
  						{
  							$extra = isset($_POST['user']['for']) && in_array($r['ID'], $_POST['user']['for']) ? ' selected="selected"' : '';
  					?>
  						<option value="<?php echo $r['ID']; ?>"<?php echo $extra; ?>><?php echo $r['LastName']; ?>, <?php echo $r['FirstName']; ?> (<?php echo $r['User']; ?>)</option>
  					<?php
  						}
  					?>
  					</select>
	  			</td>
	  		</tr>
	  		<tr><td colspan="2" class="error">
	  			<?php echo isset($for_error) && $_POST['radGroup'] == 'user' ? $for_error : ''; ?>
	  		</td></tr>
	  		<tr><td height="5"></td></tr>
	  		<tr>
	  			<th align="left">Date Range:&nbsp;</th>
	  			<td>Start:&nbsp;</td>
	  			<td><input type="text" name="user[DateStart]" id="userDateStart" size="20" maxlength="20" value="<?php echo isset($_POST['user']['DateStart']) ? $_POST['user']['DateStart'] : ''; ?>" /></td>
	  			<td>End:&nbsp;</td>
	  			<td><input type="text" name="user[DateEnd]" id="userDateEnd" size="20" maxlength="20" value="<?php echo isset($_POST['user']['DateEnd']) ? $_POST['user']['DateEnd'] : ''; ?>" /></td>
	  		</tr>
	  		<tr><td colspan="5" class="error">
	  			<?php echo isset($date_error) && $_POST['radGroup'] == 'user' ? $date_error : ''; ?>
	  		</td></tr>
	  	</table>
	  	<table cellpadding="0" cellspacing="0" border="0" width="80%">
	  		<tr>
	  			<th align="left">Sorting:</th>
	  			<td>Column:&nbsp;</td>
	  			<td>
	  				<select name="user[column]" id="userColumn" size="1">
	  					<option value="staff"<?php echo (isset($_POST['user']['column']) && $_POST['user']['column'] == 'staff') ? ' selected="selected"' : ''; ?>>Assigned Staff Name</option>
				  		<option value="name"<?php echo (isset($_POST['user']['column']) && $_POST['user']['column'] == 'name') ? ' selected="selected"' : ''; ?>>Author Name</option>
				  		<option value="cat"<?php echo (isset($_POST['user']['column']) && $_POST['user']['column'] == 'cat') ? ' selected="selected"' : ''; ?>>Ticket Category</option>
				  		<option value="date"<?php echo (isset($_POST['user']['column']) && $_POST['user']['column'] == 'date') ? ' selected="selected"' : ''; ?>>Ticket Creation Date</option>
				  		<option value="priority"<?php echo (isset($_POST['user']['column']) && $_POST['user']['column'] == 'priority') ? ' selected="selected"' : ''; ?>>Ticket Priority</option>
	  				</select>
	  			</td>
	  			<td valign="top">
	  				<input type="radio" name="user[sort]" value="asc" id="userSortAsc" <?php echo !isset($_POST['user']['sort']) || $_POST['user']['sort'] == 'asc' ? ' checked="checked"' : ''; ?>/>&nbsp;Ascending<br/>
	  				<input type="radio" name="user[sort]" value="desc" id="userSortDesc" <?php echo isset($_POST['user']['sort']) && $_POST['user']['sort'] == 'desc' ? ' checked="checked"' : ''; ?>/>&nbsp;Descending
	  			</td>
	  		</tr>
	  	</table>
	  </div>
  </td></tr>
  <tr><td colspan="2" valign="top" style="padding-left: 5px;">
  	<hr/>
  	<input type="radio" name="radGroup" id="radGroup" value="priority"<?php if ($_POST['radGroup'] == 'priority') echo ' checked="checked"'; ?> onchange="LoadOptions('priority');" />&nbsp;Priority<br/>
  	<div style="padding-left: 10px;">
	  	<table cellpadding="0" cellspacing="0" border="0" width="75%">
	  		<tr>
	  			<th align="left" valign="top">For Priority Value(s):&nbsp;</th>
	  			<td colspan="4" valign="top">
	  			<select name="priority[for][]" id="thePriority" size="5" multiple="true">
  					<?php
  						$q = "select pid, priority as name from " . DB_PREFIX . "priorities order by severity";
  						$s = mysql_query($q) or die(mysql_error());
  						while ($r = mysql_fetch_assoc($s))
  						{
  							$extra = isset($_POST['priority']['for']) && in_array($r['pid'], $_POST['priority']['for']) ? ' selected="selected"' : '';
  					?>
  						<option value="<?php echo $r['pid']; ?>"<?php echo $extra; ?>><?php echo $r['name']; ?></option>
  					<?php
  						}
  					?>
  					</select>
	  			</td>
	  		</tr>
	  		<tr><td colspan="2" class="error">
	  			<?php echo isset($for_error) && $_POST['radGroup'] == 'priority' ? $for_error : ''; ?>
	  		</td></tr>
	  		<tr><td height="5"></td></tr>
	  		<tr>
	  			<th align="left">Date Range:&nbsp;</th>
	  			<td>Start:&nbsp;</td>
	  			<td><input type="text" name="priority[DateStart]" id="priDateStart" size="20" maxlength="20" value="<?php echo isset($_POST['priority']['DateStart']) ? $_POST['priority']['DateStart'] : ''; ?>" /></td>
	  			<td>End:&nbsp;</td>
	  			<td><input type="text" name="priority[DateEnd]" id="priDateEnd" size="20" maxlength="20" value="<?php echo isset($_POST['priority']['DateEnd']) ? $_POST['priority']['DateEnd'] : ''; ?>" /></td>
	  		</tr>
	  		<tr><td colspan="5" class="error">
	  			<?php echo isset($date_error) && $_POST['radGroup'] == 'priority' ? $date_error : ''; ?>
	  		</td></tr>
	  	</table>
	  	<table cellpadding="0" cellspacing="0" border="0" width="80%">
	  		<tr>
	  			<th align="left" valign="top">Sorting:</th>
	  			<td>Column:&nbsp;</td>
	  			<td>
	  				<select name="priority[column]" id="priColumn" size="1">
	  					<option value="staff"<?php echo (isset($_POST['priority']['column']) && $_POST['priority']['column'] == 'staff') ? ' selected="selected"' : ''; ?>>Assigned Staff Name</option>
				  		<option value="name"<?php echo (isset($_POST['priority']['column']) && $_POST['priority']['column'] == 'name') ? ' selected="selected"' : ''; ?>>Author Name</option>
				  		<option value="cat"<?php echo (isset($_POST['priority']['column']) && $_POST['priority']['column'] == 'cat') ? ' selected="selected"' : ''; ?>>Ticket Category</option>
				  		<option value="date"<?php echo (isset($_POST['priority']['column']) && $_POST['priority']['column'] == 'date') ? ' selected="selected"' : ''; ?>>Ticket Creation Date</option>
				  		<option value="priority"<?php echo (isset($_POST['priority']['column']) && $_POST['priority']['column'] == 'priority') ? ' selected="selected"' : ''; ?>>Ticket Priority</option>
	  				</select>
	  			</td>
	  			<td valign="top">
	  				<input type="radio" name="priority[sort]" value="asc" id="priSortAsc" <?php echo !isset($_POST['priority']['sort']) || $_POST['priority']['sort'] == 'asc' ? ' checked="checked"' : ''; ?>/>&nbsp;Ascending
	  				<input type="radio" name="priority[sort]" value="desc" id="priSortDesc" <?php echo isset($_POST['priority']['sort']) && $_POST['priority']['sort'] == 'desc' ? ' checked="checked"' : ''; ?>/>&nbsp;Descending
	  			</td>
	  		</tr>
	  	</table>
	  </div>
  </td></tr>
  <tr><td colspan="2" valign="top" style="padding-left: 5px;">
  	<hr/>
  	<input type="radio" name="radGroup" id="radGroup"<?php if ($_POST['radGroup'] == 'tickID') echo ' checked="checked"'; ?> value="tickID" onchange="LoadOptions('tickID');" />&nbsp;Ticket ID<br/>
  	<div style="padding-left: 10px">
  		<textarea id="txtTicks" name="txtTicks" cols="30" rows="3"><?php echo isset($_POST['txtTicks']) ? $_POST['txtTicks'] : ''; ?></textarea><br/>
  		Enter Comma Delimited List of Ticket IDs
  	</div>
  </td></tr>
  <tr><td colspan="2" class="error">
  <?php echo isset($ticket_error) ? $ticket_error : ''; ?>
  <hr/>
  </td></tr>
  <tr>
  	<td valign="top">
  		<table cellpadding="0" cellspacing="0" border="0">
  			<tr>
	  			<th align="left" valign="top">Display the Following Columns (<i>Optional</i>):&nbsp;</th>
			  	<td valign="top">
			  		<input type="checkbox" name="columns[staff]" value="staff"<?php echo isset($_POST['columns']['staff']) ? ' checked="checked"' : ''; ?> />&nbsp;Assigned Staff<br/>
			  		<!--<input type="checkbox" name="columns[name]" value="name"<?php echo isset($_POST['columns']['name']) ? ' checked="checked"' : ''; ?> />&nbsp;Author Name<br/> -->
			  		<input type="checkbox" name="columns[email]" value="email"<?php echo isset($_POST['columns']['email']) ? ' checked="checked"' : ''; ?> />&nbsp;Author Email<br/>
			  		<input type="checkbox" name="columns[phone]" value="phone"<?php echo isset($_POST['columns']['phone']) ? ' checked="checked"' : ''; ?> />&nbsp;Author Phone Number<br/>
			  		<input type="checkbox" name="columns[cat]" value="category"<?php echo isset($_POST['columns']['cat']) ? ' checked="checked"' : ''; ?> />&nbsp;Ticket Category<br/>
			  		<!--<input type="checkbox" name="columns[descrip]" value="descrip"<?php echo isset($_POST['columns']['descrip']) ? ' checked="checked"' : ''; ?> />&nbsp;Ticket Description<br/>-->
			  		<input type="checkbox" name="columns[resol]" value="resol"<?php echo isset($_POST['columns']['resol']) ? ' checked="checked"' : ''; ?> />&nbsp;Ticket Resolution<br/>
			  		<!--<input type="checkbox" name="columns[date]" value="mainDate"<?php echo isset($_POST['columns']['date']) ? ' checked="checked"' : ''; ?> />&nbsp;Ticket Creation Date<br/>-->
			  		<input type="checkbox" name="columns[priority]" value="priority"<?php echo isset($_POST['columns']['priority']) ? ' checked="checked"' : ''; ?> />&nbsp;Ticket Priority<br/>
			  	</td>
			</tr>
			<tr><td colspan="2" class="error">
			<?php echo isset($column_error) ? $column_error : ''; ?>
			</td></tr>
  		</table>
  	</td>
  </tr>
  <tr><td colspan="2" valign="top">
  	<hr/>
  	Invoice Formatting Options:
  	<div style="padding-left: 7px;">
  		<input type="checkbox" name="chkOneTick" id="chkOneTick" value="1"<?php echo isset($_POST['chkOneTick']) ? ' checked="checked"' : ''; ?> />&nbsp;Display One Ticket Per Page<br/>
  		<input type="checkbox" name="chkCalcTotal" id="chkCalcTotal" value="1"<?php echo isset($_POST['chkCalcTotal']) ? ' checked="checked"' : ''; ?> />&nbsp;Calculate a Final Total
  	</div>
  </td></tr>
  <tr><td colspan="2" style="padding-left: 7px;">
  	<input type="checkbox" name="save" value="1"<?php echo isset($_POST['save']) ? ' checked="checked"' : ''; ?> />&nbsp;Save Invoice to Database<br/>
  </td></tr>
  <tr><td colspan="2" align="center">
  	<input type="submit" value="Create Invoice" name="submit" />
  </td></tr>
</form>
</table>